Maximum Size Subarray Sum Equals K

Problem

Given an array nums and a target value k, find the maximum length of a subarray that sums to k. If there isn't one, return 0 instead.

Note: The sum of the entire nums array is guaranteed to fit within the 32-bit signed integer range.

Example 1:
Given nums = [1, -1, 5, -2, 3], k = 3,
return 4. (because the subarray [1, -1, 5, -2] sums to 3 and is the longest)

Example 2:
Given nums = [-2, -1, 2, 1], k = 1,
return 2. (because the subarray [-1, 2] sums to 1 and is the longest)

Follow Up: Can you do it in O(n) time?

Solution

Brute Force: O(n^2) time

class Solution {
    public int maxSubArrayLen(int[] nums, int k) {
        if (nums == null || nums.length == 0) return 0;
        int max = 0;
        for (int i = 0; i < nums.length; i++) {
            int sum = 0;
            for (int j = i; j < nums.length; j++) {
                sum += nums[j];
                if (sum == k) max = Math.max(max, j - i + 1);
            }
        }
        return max;
    }
}

HashMap: O(n) time

class Solution {
    public int maxSubArrayLen(int[] nums, int k) {
        if (nums == null || nums.length == 0) return 0;
        Map<Integer, Integer> map = new HashMap<>();
        map.put(0, -1);
        int sum = 0, max = 0;
        for (int i = 0; i < nums.length; i++) {
            sum += nums[i];
            if (map.containsKey(sum - k)) max = Math.max(max, i - map.get(sum - k)); //No + i in calculating the length
            map.putIfAbsent(sum, i);
        }
        return max;
    }
}

Analysis

The brute force solution uses two nested loops
The i from first loop represents the starting index of subarray
The j from second loop represents the ending index of subarray
We init the sum before executing the second loop, and update it using sum += nums[j]
If we happen to have sum == k, we compare our max with current subarray length j - i + 1

The hash map solution stores the sum to index i as the key, and index i as value
We only use one loop and check if we have sum - k as key in our hash map
This is because if we have sum - k (map's key) somewhere at the array (map's value), then the subarray from map.value + 1 to i must have sum k (sum - (sum - k) = k)
Hence we update max with i - map.get(sum - k)
Notice that to make i - map.get(sum - k) as large as possible, we only put sum if it's not in the map yet

results matching ""

    No results matching ""